﻿// ブラーのような効果
// params[0]: -1.0 ~ 1.0 フォーカスのずれ度合いのようになる。詳細は後述

#version 120
uniform sampler2D	texture2d;
uniform float		args[16];
uniform float		params[16];

const int	A_TW	= 0;
const int	A_TH	= 1;

void main()
{
	if (args[A_TW] == 0) {
		gl_FragColor = gl_Color;
		return;
	}

	// pix_* はUV座標系での１ピクセルサイズ
	float pix_w = 1.0 / args[A_TW];
	float pix_h = 1.0 / args[A_TH];

	// param[0]は -1.0 ~ 1.0 であるため、最大でも隣のピクセルまでしか混ぜないため
	// 適当な数字を掛けて離れたピクセルを参照できるようにしている。
	float	defocused_x = params[0] * pix_w * 16;
	float	defocused_y = params[0] * pix_h * 16;

	vec2	tc;
	tc.x = gl_TexCoord[0].x;
	tc.y = gl_TexCoord[0].y;

	vec4	in_color = gl_Color;

	vec4 out_color = texture2D(texture2d, tc) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x + defocused_x, tc.y + defocused_y)) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x + defocused_x, tc.y)) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x , tc.y + defocused_y)) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x - defocused_x, tc.y - defocused_y)) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x + defocused_x, tc.y - defocused_y)) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x - defocused_x, tc.y + defocused_y)) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x - defocused_x, tc.y)) * in_color;
	out_color += texture2D(texture2d, vec2(tc.x , tc.y - defocused_y)) * in_color;
	out_color = out_color / 9;

    gl_FragColor = out_color;
 }
